package com.shuoeasy.test;

import java.math.BigDecimal;

import javax.sql.DataSource;

import org.junit.Before;
import org.junit.Test;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.orm.hibernate4.HibernateTransactionManager;

import com.shuoeasy.test.dao.UserDao;
import com.shuoeasy.test.entity.Orders;
import com.shuoeasy.test.entity.User;
import com.shuoeasy.test.service.OrdersService;
import com.shuoeasy.test.service.UserService;
 

/**
 * Spring学习
 */
public class AppTest {
	ApplicationContext ctx ;
	private UserService userService = null;
	private OrdersService ordersService = null;
	
	@Before
	public void init(){
		ctx = new ClassPathXmlApplicationContext("applicationContent.xml");
		userService = (UserService) ctx.getBean("userService");
		ordersService = (OrdersService) ctx.getBean("ordersService");
	}
	/**
	 * 测试数据源
	 */
	@Test
	public void testDataSource() {
		
		DataSource dataSource = (DataSource) ctx.getBean("dataSource");
		System.out.println(dataSource);
		
		HibernateTransactionManager m = (HibernateTransactionManager) ctx.getBean("transactionManager");
		System.out.println(m);
		
	}
	
	/**
	 * 测试添加用户
	 */
	@Test
	public void testAddUser(){
		User user = new User();
		user.setUserName("张三");
		user.setMoney(BigDecimal.ZERO);
		userService = (UserService) ctx.getBean("userService");
		userService.add(user);
	}
	
	/**
	 * 测试添加订单
	 */
	@Test
	public void testAddOrders(){
		
		User user = userService.find(1);
		
		Orders orders1 = new Orders();
		orders1.setTitle("订单1");
		orders1.setUser(user);
		ordersService.add(orders1);
		
		Orders orders2 = new Orders();
		orders2.setTitle("订单2");
		orders2.setUser(user);
		ordersService.add(orders2);
	}
	
	/**
	 * 测试转账
	 */
	@Test
	public void transfer(){
		int fromUid = 1;
		int toUid = 2;
		BigDecimal money =new BigDecimal("0.01");
		
		userService.transfer(fromUid, toUid, money);
	}
}
